'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (Model) {
  return {
    list: function list(req, res) {
      Model.find().sort('-created_at').exec(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        res.json({ result: result });
      });
    },

    new: function _new(req, res) {
      if (!req.body) {
        res.status(403).end();
        return;
      }

      var newRecord = new Model(req.body);

      newRecord.save(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        res.json({ result: result });
      });
    },

    get: function get(req, res) {
      var _id = req.params.id;


      Model.findOne({ _id: _id }).exec(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        res.json({ result: result });
      });
    },

    update: function update(req, res) {
      var _id = req.params.id;


      if (!req.body) {
        res.status(403).end();
        return;
      }

      Model.findOneAndUpdate({ _id: _id }, { $set: req.body }, { new: true }).exec(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        res.json({ result: result });
      });
    },

    delete: function _delete(req, res) {
      var _id = req.params.id;


      Model.findById(_id).exec(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        result.remove(function () {
          res.status(200).end();
        });
      });
    }
  };
};
//# sourceMappingURL=actionCreator.js.map