'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _mongoose = require('mongoose');

var _mongoose2 = _interopRequireDefault(_mongoose);

var _commonErrors = require('common-errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_SCHEMA = {
  created_at: { type: 'Date', default: Date.now, required: false },
  updated_at: { type: 'Date', default: Date.now, required: false }
};

exports.default = function (name, route) {
  var schema = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  if (!name) {
    throw new _commonErrors.ArgumentNullError('model name');
  }

  if (!route) {
    throw new _commonErrors.ArgumentNullError('route');
  }

  if ((0, _lodash.isEmpty)(schema)) {
    throw new _commonErrors.ArgumentNullError('schema');
  }

  var modelSchema = new _mongoose2.default.Schema(Object.assign({}, schema, DEFAULT_SCHEMA));
  return _mongoose2.default.model(name, modelSchema);
};
//# sourceMappingURL=modelCreator.js.map