'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Express middleware to handle error response
 * @param {object} server - Express.js instance
 */

exports.default = function (server) {
  // Disable for the unused next params,
  // which is neccessary to exist for error handling identification
  /* eslint-disable no-unused-vars */
  server.use(function (err, req, res, next) {
    res.status(err.status || 500).json({
      message: err.message,
      error: server.get('env') !== 'production' ? err.stack : {}
    });
  });
};
//# sourceMappingURL=errorHandling.js.map