'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = connect;
exports.disconnect = disconnect;

var _logatim = require('logatim');

var _logatim2 = _interopRequireDefault(_logatim);

var _mongoose = require('mongoose');

var _mongoose2 = _interopRequireDefault(_mongoose);

var _commonErrors = require('common-errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function connect(connectionUri, done) {
  if (!connectionUri) {
    _logatim2.default.error(new _commonErrors.ArgumentNullError('MONGODB_URL'));
    return;
  }

  _mongoose2.default.connect(connectionUri);

  _mongoose2.default.connection.on('error', function (error) {
    _logatim2.default.error(new _commonErrors.data.MongoDBError('Fail to connect database: ' + connectionUri, error));
  });

  _mongoose2.default.connection.once('open', function () {
    _logatim2.default.setLevel('info');
    _logatim2.default.green.info('Database connected!');
    done();
  });
}

function disconnect(done) {
  _mongoose2.default.connection.db.dropDatabase(function (err) {
    if (err) {
      _logatim2.default.error(new _commonErrors.data.MongoDBError('Fail to drop database', err));
    }

    _mongoose2.default.connection.close(done);
  });
}
//# sourceMappingURL=database.js.map