'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _commonErrors = require('common-errors');

exports.default = function (server) {
  return new Promise(function (resolve, reject) {
    if (!server.get('port')) {
      reject(new _commonErrors.ArgumentNullError('port'));
      return;
    }

    if (!server.get('env')) {
      reject(new _commonErrors.ArgumentNullError('env'));
      return;
    }

    server.listen(server.get('port'), function () {
      resolve('Server is running in ' + server.get('env') + ' at ' + server.get('port'));
    });
  });
};
//# sourceMappingURL=listener.js.map