'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (Model) {
  return {
    list: function list(req, res) {
      Model.find().sort('-dateAdded').exec(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        res.json({ result: result });
      });
    },

    new: function _new(req, res) {
      if (!req.body) {
        res.status(403).end();
        return;
      }

      var newRecord = new Model(req.body);

      newRecord.save(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        res.json({ result: result });
        return;
      });
    },

    get: function get(req, res) {
      var id = req.params.id;


      Model.findOne({ id: id }).exec(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        res.json({ result: result });
      });
    },

    delete: function _delete(req, res) {
      Model.findById(req.body.id).exec(function (err, result) {
        if (err) {
          res.status(500).send(err);
          return;
        }

        result.remove(function () {
          res.status(200).end();
        });
      });
    }
  };
};
//# sourceMappingURL=action.js.map