'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chai = require('chai');

var _supertest = require('supertest');

var _supertest2 = _interopRequireDefault(_supertest);

var _mockServer = require('./mockServer');

var _mockServer2 = _interopRequireDefault(_mockServer);

var _config = require('../config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TestCreator = function () {
  function TestCreator(route, model, routeName) {
    var mockData = arguments.length <= 3 || arguments[3] === undefined ? [] : arguments[3];

    _classCallCheck(this, TestCreator);

    this.server = (0, _mockServer2.default)(route);
    this.model = model;
    this.mockData = mockData;
    this.requestUrl = '/' + _config.API_ROUTE_NAME_SPACE + '/' + routeName;
  }

  _createClass(TestCreator, [{
    key: 'list',
    value: function list(done) {
      var _this = this;

      (0, _supertest2.default)(this.server).get(this.requestUrl).set('Accept', 'application/json').expect(200).end(function (err, res) {
        _this.model.find().exec(function (findError, results) {
          (0, _chai.expect)(results.length).to.equal(res.body.result.length);
          done();
        });
      });
    }
  }, {
    key: 'get',
    value: function get(done) {
      var _this2 = this;

      this.model.find().exec(function (findError, results) {
        (0, _chai.expect)(results.length > 0).to.equal(true);

        var _id = results[0]._id;


        (0, _supertest2.default)(_this2.server).get(_this2.requestUrl + '/' + _id).set('Accept', 'application/json').expect(200).end(function (err, res) {
          var result = res.body.result;

          var targetMock = _this2.mockData.find(function (eachMock) {
            return eachMock.email === result.email;
          });

          (0, _chai.expect)(targetMock).to.not.be.empty;

          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = Object.keys(targetMock)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var key = _step.value;

              (0, _chai.expect)(key in result).to.equal(true);
              (0, _chai.expect)(targetMock[key] === result[key]).to.equal(true);
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          done();
        });
      });
    }
  }, {
    key: 'new',
    value: function _new(newData, done) {
      var _this3 = this;

      (0, _supertest2.default)(this.server).post(this.requestUrl).send(newData).set('Accept', 'application/json').expect(200).end(function (err, res) {
        var result = res.body.result;

        (0, _chai.expect)(newData.email).to.equal(result.email);
        (0, _chai.expect)(newData.display_name).to.equal(result.display_name);

        _this3.model.find().exec(function (findError, dbResults) {
          (0, _chai.expect)(dbResults.length > _this3.mockData.length).to.equal(true);

          (0, _chai.expect)(dbResults.find(function (dbResult) {
            return dbResult.email === newData.email;
          })).to.not.be.empty;

          done();
        });
      });
    }
  }, {
    key: 'update',
    value: function update(updatedData, targetKey, done) {
      var _this4 = this;

      this.model.findOne(_defineProperty({}, targetKey, updatedData[targetKey])).exec(function (findOneError, result) {
        (0, _chai.expect)(result).to.have.property(targetKey);
        var _id = result._id;


        (0, _supertest2.default)(_this4.server).put(_this4.requestUrl + '/' + _id).send(updatedData).set('Accept', 'application/json').expect(200).end(function (err, res) {
          var resResult = res.body.result;

          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = Object.keys(updatedData)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var key = _step2.value;

              (0, _chai.expect)(key in resResult).to.equal(true);
              (0, _chai.expect)(updatedData[key] === resResult[key]).to.equal(true);
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }

          _this4.model.findById(_id).exec(function (findByIdError, dbResult) {
            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
              for (var _iterator3 = Object.keys(updatedData)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                var key = _step3.value;

                (0, _chai.expect)(key in dbResult).to.equal(true);
                (0, _chai.expect)(updatedData[key] === dbResult[key]).to.equal(true);
              }
            } catch (err) {
              _didIteratorError3 = true;
              _iteratorError3 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }
              } finally {
                if (_didIteratorError3) {
                  throw _iteratorError3;
                }
              }
            }

            done();
          });
        });
      });
    }
  }, {
    key: 'delete',
    value: function _delete(targetKey, done) {
      var _this5 = this;

      this.model.find().exec(function (findAllError, findAllResults) {
        (0, _chai.expect)(findAllResults.length > 0).to.equal(true);

        var _id = findAllResults[0]._id;


        (0, _supertest2.default)(_this5.server).del(_this5.requestUrl + '/' + _id).set('Accept', 'application/json').expect(200).end(function (err, res) {
          (0, _chai.expect)(res.body).to.deep.equal({});

          _this5.model.find().exec(function (findAllAfterRequestError, results) {
            (0, _chai.expect)(results.length).to.equal(_this5.mockData.length - 1);

            results.forEach(function (result) {
              (0, _chai.expect)(result[targetKey]).to.not.equal(targetKey);
            });

            done();
          });
        });
      });
    }
  }]);

  return TestCreator;
}();

exports.default = TestCreator;
//# sourceMappingURL=TestCreator.js.map