'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mongoose = require('mongoose');

var _mongoose2 = _interopRequireDefault(_mongoose);

var _commonErrors = require('common-errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (connectionUri) {
  return new Promise(function (resolve, reject) {
    if (!connectionUri) {
      reject(new _commonErrors.ArgumentNullError('MONGODB_URL'));
      return;
    }

    _mongoose2.default.connect(connectionUri);

    _mongoose2.default.connection.on('error', function (error) {
      reject(new _commonErrors.data.MongoDBError('Fail to connect database: ' + connectionUri, error));
      return;
    });

    _mongoose2.default.connection.once('open', function () {
      resolve('Database connected!');
    });
  });
};
//# sourceMappingURL=connectDb.js.map