'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _clearData = require('./clearData');

var _clearData2 = _interopRequireDefault(_clearData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (Model) {
  var data = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

  if (!Array.isArray(data)) {
    return Promise.reject(new Error('Data: ' + data + ' must be an array'));
  }

  var models = data.map(function (eachData) {
    return new Model(eachData);
  }).map(function (eachModel) {
    return eachModel.save();
  });

  return (0, _clearData2.default)(Model).then(function () {
    return Promise.all(models);
  });
};
//# sourceMappingURL=seedData.js.map